const { contextBridge } = require('electron')
const net = require('net');

let socket=null
contextBridge.exposeInMainWorld('tfTask', {
    openSocket: function ({port,onData,onStart,onClose}) {
        socket = net.connect({port}, () => {
            onStart()
            socket.on('data', (data) => {
                onData(parseData(data.toString()))
            });
            socket.on('close', () => {
                socket=null
                onClose()
            });
        });
        socket.on('error', e => {
            socket=null
            onClose();
        });
    },
    sendToSocket: function (data) {
        if(socket){
            socket.write(JSON.stringify(data));
        }
    },
    closeSocket: function () {
        socket && socket.end();
        socket = null
    },
    checkSocket: function () {
        return socket === null
    }
})

function parseData(str){
    try{
        return JSON.parse(str)
    }catch (e) {
        console.log('e',str, e);
        return {}
    }
}
